# This file was created automatically by SWIG.
import pixelgroupsubproblemc
from ooflib.SWIG.engine.csubproblem import CSubProblemPtr
from ooflib.SWIG.common.lock import LockPtr
class CPixelGroupSubProblemPtr(CSubProblemPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __del__(self,pixelgroupsubproblemc=pixelgroupsubproblemc):
        if self.thisown == 1 :
            pixelgroupsubproblemc.delete_CPixelGroupSubProblem(self)
    def __setattr__(self,name,value):
        if name == "precomputeLock" :
            pixelgroupsubproblemc.CPixelGroupSubProblem_precomputeLock_set(self,value.this)
            return
        if name == "precomputeRequired" :
            pixelgroupsubproblemc.CPixelGroupSubProblem_precomputeRequired_set(self,value)
            return
        self.__dict__[name] = value
    def __getattr__(self,name):
        if name == "precomputeLock" : 
            return LockPtr(pixelgroupsubproblemc.CPixelGroupSubProblem_precomputeLock_get(self))
        if name == "precomputeRequired" : 
            return pixelgroupsubproblemc.CPixelGroupSubProblem_precomputeRequired_get(self)
        raise AttributeError,name
    def __repr__(self):
        return "<C CPixelGroupSubProblem instance at %s>" % (self.this,)
class CPixelGroupSubProblem(CPixelGroupSubProblemPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(pixelgroupsubproblemc.new_CPixelGroupSubProblem,_args,_kwargs)
        self.thisown = 1






#-------------- FUNCTION WRAPPERS ------------------



#-------------- VARIABLE WRAPPERS ------------------



#-------------- USER INCLUDE -----------------------

# -*- python -*-
# $RCSfile: pixelgroupsubproblem.spy,v $
# $Revision: 1.11 $
# $Author: langer $
# $Date: 2009-10-16 22:23:37 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

from ooflib.SWIG.common import switchboard
from ooflib.common import debug
from ooflib.common import registeredclass
from ooflib.common.IO import pixelgroupparam
from ooflib.engine import subproblemtype

# PixelGroupSubProblems need to know if their pixelgroup has changed,
# so that they can reset their cached lists of nodes, etc.  To do
# this, a PixGrpSubProbNotifier object is installed as a switchboard
# callback.  The callback is installed by the startup functions of the
# Registration.  startup is called by the SubProblemContext when it's
# created.

class PixGrpSubProbNotifier:
    def __init__(self, subpctxt):
        self.subpctxt = subpctxt
        param = subpctxt.subptype.getRegistration().getParameter('group')
        self.groupname = param.value
    def __call__(self, group, microstructurename):
        if (group.name() == self.groupname and
            self.subpctxt.getMicrostructure().name() == microstructurename):
            self.subpctxt.redefined()

def _startup(subpctxt):
    subpctxt.requestCallback("changed pixel group",
                             PixGrpSubProbNotifier(subpctxt))

##############

class PixelGroupSubProblem(subproblemtype.SubProblemType):
    def __init__(self, group):
        self.group = group
    def create(self):
        return CPixelGroupSubProblem(self.group)

registeredclass.Registration(
    "PixelGroup",
    subproblemtype.SubProblemType,
    PixelGroupSubProblem,
    ordering=3,
    startup=_startup,
    params=[pixelgroupparam.PixelGroupParameter(
            "group",
            tip="The name of a pixel group.")],
    
    tip="A subproblem containing all elements whose dominant pixel is in a given pixel group.",
    discussion="""<para>

    A <classname>PixelGroupSubProblem</classname> is a &subproblem;
    defined to include all &elems; whose
    <link linkend="Section-Concepts-Skeleton-Homogeneity">dominant pixel</link>
    is a member of the given &pixelgroup;.

    </para>""" 
    )

